*L+     ;  ⨭
*D-     ;   hex'
                org     23881
init            di
                xor     a               ; ⨬ 
                out     (#FE),a
                ld      hl,#4000        ; ⨬ ࠭
                ld      de,#4001
                ld      bc,#1AFF
                ld      (hl),l
                ldir
; ७ᨬ 稪
                ld      sp,#7FFF
                ld      hl,loaderArea
                ld      de,#7F00
                push    de
                ld      bc,end-loader
                ldir
; ᨬ  ᪮
                ld      a,(23833)
                or      #3C
                ld      (driveNum),a
                ret
loaderArea
                disp    #7F00
loader          ld      de,(#5CF4)      ; ஦/ᥪ  DE
                ld      iy,pageTable
nextPage
                ld      a,(iy+0)
                inc iy
                ld      bc,#7ffd
                out     (c),a
                ld      hl,#C000
                ld      b,#40
                cp      #15
                jr      z,loadPage5
                call    readSecs
                jr      nextPage
loadPage5
                dec     b
                call    readSecs        ; 㧨 ᥪ ஬ ᫥

; ⠭ 祭  ॣ஢  .
                ld      bc,#7FFD
                ld      a,0             ;  ⨢ ࠭
                out     (c),a
                ld      iy,0
                exx
                ld      hl,0
                ld      de,0
                ld      bc,0
                exx
                ld      a,0
                out     (#FE),a         ; 梥 
                ld      hl,0            ; AF'
                push    hl
                pop     af
                ex      af,af'
; -------------------------------------------------
                call    findTrk
                ld      sp,0            ; ⠭ ᢥ
                push    de
                ld      hl,loader2
                ld      de,0            ;  ࠧ饭 稪
                push    de
                ld      bc,loader2end-loader2
                ldir
                ld      hl,#7F00
                ret

loader2         pop     de
                ld      ix,#2F1B
                call    trdos           ; ⠥ ᫥ ᥪ
                ld      ix,0
                ld      de,0
                ld      bc,0
                ld      a,0
                ld      i,a
                ld      a,0
                ld      r,a
                ld      hl,0            ; AF
                push    hl
                pop     af
                ld      hl, 0
                ld      sp,0
                im      1
                ei
                jp      0
loader2end
;---------------------------------------------------------------------
readSecs        call    findTrk
load            push    de
                ld      ix,#2F1B
                call    trdos
                pop     de
nextSec         inc     h
                inc     e
                bit     4,e
                jr      z,onSameTrk
                ld      e,0
                inc     d
                djnz    readSecs
                ret
onSameTrk       djnz    load
                ret
;----------------------------------------------------------------------
findTrk         ld      c,d
                srl     c
driveNum        equ     $+1
                ld      a,#3C
                jr      nc,gotoTrk
                sub     #10
gotoTrk         ld      ix,#2F4D
;        ---------------------------------
trdos           push    ix
                jp      #3D2F
;----------------------------------------------------------------------
pageTable       db      0,0,0,0,0,0,0,0

end
                endd